Subject: Re: [PATCH v13 3/5] rust: time: Introduce Instant type

From: Boqun Feng <[email-masked]>
Date: Sun, 13 Apr 2025 17:06:15 -0700

On Sun, Apr 13, 2025 at 07:43:08PM +0900, FUJITA Tomonori wrote:
> Introduce a type representing a specific point in time. We could use
> the Ktime type but C's ktime_t is used for both timestamp and
> timedelta. To avoid confusion, introduce a new Instant type for
> timestamp.
> 
> Rename Ktime to Instant and modify their methods for timestamp.
> 
> Implement the subtraction operator for Instant:
> 
> Delta = Instant A - Instant B
> 
> Reviewed-by: Boqun Feng <[email-masked]>

I probably need to drop my Reviewed-by because of something below:

> Reviewed-by: Gary Guo <[email-masked]>
> Reviewed-by: Fiona Behrens <[email-masked]>
> Tested-by: Daniel Almeida <[email-masked]>
> Reviewed-by: Andreas Hindborg <[email-masked]>
> Signed-off-by: FUJITA Tomonori <[email-masked]>
> ---
[...]
> diff --git a/rust/kernel/time/hrtimer.rs b/rust/kernel/time/hrtimer.rs
> index ce53f8579d18..27243eaaf8ed 100644
> --- a/rust/kernel/time/hrtimer.rs
> +++ b/rust/kernel/time/hrtimer.rs
> @@ -68,7 +68,7 @@
>  //! `start` operation.
>  
>  use super::ClockId;
> -use crate::{prelude::*, time::Ktime, types::Opaque};
> +use crate::{prelude::*, time::Instant, types::Opaque};
>  use core::marker::PhantomData;
>  use pin_init::PinInit;
>  
> @@ -189,7 +189,7 @@ pub trait HrTimerPointer: Sync + Sized {
>  
>      /// Start the timer with expiry after `expires` time units. If the timer was
>      /// already running, it is restarted with the new expiry time.
> -    fn start(self, expires: Ktime) -> Self::TimerHandle;
> +    fn start(self, expires: Instant) -> Self::TimerHandle;

We should be able to use what I suggested:

	https://lore.kernel.org/rust-for-linux/Z_ALZsnwN53ZPBrB@boqun-archlinux/	

to make different timer modes (rel or abs) choose different expire type.

I don't think we can merge this patch as it is, unfortunately, because
it doesn't make sense for a relative timer to take an Instant as expires
value.

Regards,
Boqun

>  }
[...]